local tmp = package.path
package.path = package.path .. ";UAV.rte/?.lua"
require("common")
package.path = tmp

function Create(self)
	UAVInitialize(self)
	
	-- specific for this craft
	self.occlusion = 68
	self.payload = 28
	self.payloadRof = 70	-- time in ms between launches
end

function Destroy(self)
	UAVDestroy(self)
end

function Update(self)
	self.angle = self.RotAngle
	if self.HFlipped then
		self.angle = self.angle + math.pi
	end
	
	if self.RotAngle > math.pi or self.RotAngle < -math.pi then
		self.RotAngle = 0
		self.HFlipped = not self.HFlipped
	end
	
	-- movement in direction of view angle
	self.speed = math.abs(self.Vel.Magnitude * math.cos(math.abs(self.Vel.AbsRadAngle - self.RotAngle)))
	
	UAVMove(self)
		
	if ToActor(self):IsPlayerControlled() then
		self.playerCtrl = true
		UAVMap(self)
		
		-- MGs
		if self:GetController():IsState(Controller.PRIMARY_ACTION) then
			if self.ammo > 0 then
				UAVFireMG(self)
			else
				UAVAddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
		
		-- specific for this craft
		if self.DropTimer:IsPastSimMS(self.payloadRof) and (self:GetController():IsMouseControlled() and UAVSecondaryKey()) or
			(not self:GetController():IsMouseControlled() and self:GetController():IsState(Controller.AIM_SHARP))
		then
			if self.payload > 0 then	-- Fire Rocket
				self.DropTimer:Reset()
				
				local Rocket = CreateAEmitter("FFAR")
				Rocket.Vel = UAVOffset(self.Vel, self.angle, 20)
				Rocket.Pos = self.Pos + self:RotateOffset(Vector(math.abs(Rocket.SpriteOffset.X) + self.speed, math.abs(Rocket.SpriteOffset.Y) + 14))
				Rocket.RotAngle = self.angle
				MovableMan:AddParticle(Rocket)
				
				local Blast  = CreateAEmitter("Back Blast")
				Blast.Vel = self.Vel
				Blast.Pos = self.Pos + self:RotateOffset(Vector(-10, 14))
				Blast.RotAngle = self.angle
				MovableMan:AddParticle(Blast)
				
				self.payload = self.payload - 1
				if self.payload % 9 == 0 then
					self:AddInventoryItem(CreateHDFirearm(".", "UAV.rte"))	-- Negative Gold
				end
			else
				UAVAddIcon(self, CreateMOSParticle("No Ammo"), 5)
			end
		end
	elseif self.playerCtrl then
		UAVDestroy(self)
	end
end